package com.sun.xml.internal.ws.client;

import java.security.AccessController;
import java.lang.reflect.Method;
import javax.xml.ws.WebEndpoint;
import java.io.IOException;
import javax.xml.ws.WebServiceException;
import com.sun.xml.internal.ws.util.JAXWSUtils;
import javax.xml.ws.WebServiceClient;
import java.security.PrivilegedAction;
import javax.xml.namespace.QName;
import java.util.ArrayList;

final class SCAnnotations
{
    final ArrayList<QName> portQNames;
    final ArrayList<Class> classes;
    
    SCAnnotations(final Class<?> sc) {
        this.portQNames = new ArrayList();
        this.classes = new ArrayList();
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                WebServiceClient wsc = (WebServiceClient)sc.getAnnotation(WebServiceClient.class);
                if (wsc == null) {
                    throw new WebServiceException("Service Interface Annotations required, exiting...");
                }
                String tns = wsc.targetNamespace();
                try {
                    JAXWSUtils.getFileOrURL(wsc.wsdlLocation());
                }
                catch (IOException e) {
                    throw new WebServiceException(e);
                }
                for (Method method : sc.getDeclaredMethods()) {
                    WebEndpoint webEndpoint = (WebEndpoint)method.getAnnotation(WebEndpoint.class);
                    if (webEndpoint != null) {
                        String endpointName = webEndpoint.name();
                        QName portQName = new QName(tns, endpointName);
                        SCAnnotations.this.portQNames.add(portQName);
                    }
                    Class<?> seiClazz = method.getReturnType();
                    if (seiClazz != Void.TYPE) {
                        SCAnnotations.this.classes.add(seiClazz);
                    }
                }
                return null;
            }
        });
    }
}
